## tulip 4.8.0dfsg

=== CMakeLists.txt ===
IF(WIN32)
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
ELSEIF(APPLE)
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12)
ELSE()
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.3)
ENDIF(WIN32)

# Remove CMake warnings related to Qt5
IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF(POLICY CMP0020)

# Remove CMake warnings related to rpath on MacOS
IF(POLICY CMP0042)
  CMAKE_POLICY(SET CMP0042 NEW)
ENDIF(POLICY CMP0042)

PROJECT(tulip)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR})

## ========================================================
## Build type detection
## ========================================================

IF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
  SET(CMAKE_DEBUG_MODE TRUE)
ELSE(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
  SET(CMAKE_DEBUG_MODE FALSE)
ENDIF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")

## ========================================================
## Check processor architecture
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_SIZEOF_VOID_P}" "8" I64)
IF(I64)
  SET(PROCESSOR_ARCHITECTURE "64")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DI64")
ELSE(I64)
  SET(PROCESSOR_ARCHITECTURE "32")
ENDIF(I64)

## ========================================================
## Consider FreeBSD as Linux
## ========================================================
EXEC_PROGRAM(uname OUTPUT_VARIABLE UNAME_OUT)
STRING(COMPARE EQUAL "${UNAME_OUT}" "Linux" LINUX)
IF(NOT LINUX)
  STRING(COMPARE EQUAL "${UNAME_OUT}" "GNU/kFreeBSD" LINUX)
ENDIF(NOT LINUX)

## ========================================================
## Operating system preprocessor macros
## ========================================================
IF(LINUX)
  ADD_DEFINITIONS("-D_LINUX")
ENDIF(LINUX)
IF(WIN32)
  ADD_DEFINITIONS("-D_WIN32")
ENDIF(WIN32)
IF(APPLE)
  ADD_DEFINITIONS("-D__APPLE__")
ENDIF(APPLE)

## ========================================================
## Tulip version variables
## ========================================================
SET(TulipMajorVersion 4)
SET(TulipMinorVersion 8)
SET(TulipReleaseVersion 0)
SET(TulipVersionSeparator .)
IF(MSVC) #specific options for Visual Studio
  SET(TulipVersionSeparator _)
ENDIF()
SET(TulipVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}${TulipVersionSeparator}${TulipReleaseVersion}")
SET(TulipMMVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}")
SET(TulipIntVersion "${TulipMajorVersion}${TulipMinorVersion}${TulipReleaseVersion}")

## ========================================================
## Tulip libraries names
## ========================================================
SET(LibTulipCoreName "tulip-core-${TulipMMVersion}")
SET(LibTulipOglName "tulip-ogl-${TulipMMVersion}")
SET(LibTulipGUIName "tulip-gui-${TulipMMVersion}")
SET(LibTulipPythonName "tulip-python-${TulipMMVersion}")
SET(LibTulipOGDFName "tulip-ogdf-${TulipMMVersion}")
SET(LibStlPythonBindingsName "stl-python-bindings")
SET(LibTulipCorePythonBindingsName "tulip-core-python-bindings")
SET(LibTulipOGLPythonBindingsName "tulip-opengl-python-bindings")
SET(LibTulipGUIPythonBindingsName "tulip-gui-python-bindings")
SET(TulipLibs ${LibTulipCoreName} ${LibTulipOglName} ${LibTulipGUIName} ${LibTulipOGDFName})

## ========================================================
## Current year (used in documentation config files)
## ========================================================
IF(WIN32)
  EXECUTE_PROCESS(COMMAND "cmd.exe" "/c" "echo" "%DATE:~6,4%" OUTPUT_VARIABLE CurrentYear OUTPUT_STRIP_TRAILING_WHITESPACE)
  # CMake variable to check if we run cmake on a 64 bits Windows
  STRING(COMPARE EQUAL "${CMAKE_SYSTEM_PROCESSOR}" "AMD64" WIN_AMD64)
ELSEIF(UNIX)
  EXECUTE_PROCESS(COMMAND "date" "+%Y" OUTPUT_VARIABLE CurrentYear OUTPUT_STRIP_TRAILING_WHITESPACE)
ENDIF()

## ========================================================
## Configure file for uninstall target
## ========================================================
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake VERBATIM)

## ========================================================
## Additional macros
## ========================================================
INCLUDE(TulipUseFile.cmake)

## ========================================================
## Profiling
## ========================================================
SET(BUILD_CODE_COVERAGE OFF CACHE BOOL "Do you want to build for code coverage ? [OFF|ON]")

## ========================================================
## Compiler-specific options
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_CXX_COMPILER_ID}" "Clang" CLANG)

SET_COMPILER_OPTIONS()

IF(BUILD_CODE_COVERAGE)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
ENDIF()

## ========================================================
## CORE ONLY
## this used to have a minimal build of Tulip without
## any of the opengl, qt or python components
## ========================================================
IF(NOT EXISTS ${PROJECT_SOURCE_DIR}/FindQtX.cmake OR EMSCRIPTEN)
  SET(BUILD_CORE_ONLY ON)
  MESSAGE("You can only configure a core build of Tulip.")
ELSE()
  SET(BUILD_CORE_ONLY OFF CACHE BOOL "Do you want a minimal build of Tulip ? [ON|OFF]")
ENDIF()

IF(BUILD_CORE_ONLY AND LINUX)
# the macro ADD_CORE_FILES will be used
# to collect the files needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  MACRO(ADD_CORE_FILES files)
    SET(CURRENT_SOURCE_DIR ".")
    IF(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      EXECUTE_PROCESS(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
                      OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    ENDIF()
    IF(${files} STREQUAL ".")
      SET(ENV{CORE_FILES} "$ENV{CORE_FILES} \$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f -print)")
    ELSE()
      FOREACH(core_file ${ARGV})
	SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${CURRENT_SOURCE_DIR}/${core_file}")
      ENDFOREACH()
    ENDIF()
  ENDMACRO()
  ADD_CORE_FILES(CMakeLists.txt cmake_uninstall.cmake.in TulipUseFile.cmake)
# the macro ADD_CORE_DIRECTORY_EXCEPT will be used
# to exclude the files not needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  MACRO(ADD_CORE_DIRECTORY_EXCEPT files)
    SET(CURRENT_SOURCE_DIR ".")
    IF(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      EXECUTE_PROCESS(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
                      OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    ENDIF()
    SET(find_command "\$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f")
    FOREACH(exclude_file ${ARGV})
      SET(find_command "${find_command} -a ! -name \"${exclude_file}\"")
    ENDFOREACH()
    SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${find_command} -print)")
  ENDMACRO()
ELSE()
  MACRO(ADD_CORE_FILES files)
  ENDMACRO()
  MACRO(ADD_CORE_DIRECTORY_EXCEPT files)
  ENDMACRO()
ENDIF()

SET(BUILD_PYTHON_COMPONENTS ON CACHE BOOL "Do you want to build Tulip Python components ? [ON|OFF]")
IF(BUILD_PYTHON_COMPONENTS)
  SET(TULIP_PYTHON_FOLDER ${CMAKE_BINARY_DIR}/library/tulip-python/bindings/tulip-core/tulip_module/tulip)
  SET(TULIPOGL_PYTHON_FOLDER ${CMAKE_BINARY_DIR}/library/tulip-python/bindings/tulip-gui/tulipgui_module/tulipogl)
  SET(TULIPGUI_PYTHON_FOLDER ${CMAKE_BINARY_DIR}/library/tulip-python/bindings/tulip-gui/tulipgui_module/tulipgui)
  SET(TULIP_PYTHON_NATIVE_FOLDER ${TULIP_PYTHON_FOLDER}/native)
  SET(TULIPOGL_PYTHON_NATIVE_FOLDER ${TULIPOGL_PYTHON_FOLDER}/native)
  SET(TULIPGUI_PYTHON_NATIVE_FOLDER ${TULIPGUI_PYTHON_FOLDER}/native)
  IF(WIN32 OR APPLE)
    SET(ACTIVATE_PYTHON_WHEELS_TARGETS OFF CACHE BOOL "Add a wheel make target for generating Tulip Python modules wheels ? [ON|OFF]")
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS AND APPLE)
      # build universal binaries when generating Tulip Python wheels for MacOs
      SET(CMAKE_OSX_ARCHITECTURES "i386;x86_64")
      # build binaries with install rpath when generating Tulip Python wheels for MacOs
      # as we don't install the project in that case
      SET(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS AND APPLE)
  ENDIF(WIN32 OR APPLE)
ENDIF(BUILD_PYTHON_COMPONENTS)

## ========================================================
## Required packages
## ========================================================
IF(MINGW)
  # Set some common libraries and headers search paths for MinGW
  SET(CMAKE_LIBRARY_PATH "${MINGW_BIN_PATH};${MINGW_LIB_PATH};${MINGW_LIB64_PATH};${CMAKE_LIBRARY_PATH}")
  SET(CMAKE_INCLUDE_PATH "${MINGW_INCLUDE_PATH};${MINGW_INCLUDE_PATH}/freetype2;${MINGW_INCLUDE_PATH}/libpng*;${CMAKE_INCLUDE_PATH}")

  # Check if libintl is present in the MinGW build environment
  FIND_LIBRARY(LIBINTL_FOUND intl PATHS ${MINGW_LIB_PATH} ${MINGW_LIB64_PATH} NO_DEFAULT_PATH)
ENDIF(MINGW)

# Don't need to find zlib when compiling with emscripten as there is an available emscripten port of it
IF(NOT EMSCRIPTEN)

  # ZLIB
  FIND_PACKAGE(ZLIB REQUIRED)

ENDIF(NOT EMSCRIPTEN)

# Yajl
SET(YAJL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/yajl/src ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/yajl/src/api ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/yajl/yajl-2.1.0/include)

# OpenMP
IF(NOT CLANG)
  FIND_PACKAGE(Threads)
  OPTION(ENABLE_OPENMP "Do you want to enable OpenMP?" ON)
  IF(ENABLE_OPENMP)
    FIND_PACKAGE(OpenMP)
    IF(OPENMP_FOUND)
      SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_CXX_FLAGS}")
      SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${OpenMP_CXX_FLAGS}")
      SET(OPENMP_CXX_FLAGS "${OpenMP_CXX_FLAGS}")
      IF(WIN32)
        IF(MSVC)
          SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /openmp")
          SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /openmp")
          SET(OPENMP_CXX_FLAGS "/openmp")
        ELSE()
          SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp ${CMAKE_THREAD_LIBS_INIT}")
          SET(OPENMP_LIBRARIES "-lgomp -lpthread")
        ENDIF()
      ENDIF()
    ELSE(OPENMP_FOUND)
      IF(WIN32)
        STRING(COMPARE NOTEQUAL "${OpenMP_C_FLAGS}" "" OMP_CFLAGS)
        IF(OMP_CFLAGS)
          # Force setting OpenMP flags on Windows plateforms
          SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_C_FLAGS}")
          SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${OpenMP_C_FLAGS}")
          SET(OPENMP_CXX_FLAGS "${OpenMP_C_FLAGS}")
          IF(NOT MSVC)
            SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
            SET(OPENMP_LINKER_FLAGS "${OpenMP_C_FLAGS}")
            SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp -lpthread")
            SET(OPENMP_LIBRARIES "-lgomp -lpthread")
          ENDIF(NOT MSVC)
            SET(OPENMP_FOUND TRUE)
          ELSE(OMP_CFLAGS)
            MESSAGE("OpenMP not found: multithreaded code will not be used")
        ENDIF(OMP_CFLAGS)
      ELSE(WIN32)
        MESSAGE("OpenMP not found: multithreaded code will not be used")
      ENDIF(WIN32)
      ## ========================================================
      ## Enable debugging of OpenMP
      ## ========================================================
      IF(CMAKE_DEBUG_MODE AND NOT CHECK_MEMORY)

=== bundlers/CMakeLists.txt ===
IF(WIN32)
ADD_SUBDIRECTORY(win)
ENDIF(WIN32)

=== demos/CMakeLists.txt ===
SET(BUILD_DEMOS OFF CACHE BOOL "Build demo executables and libraries and install them in a demo folder")

IF(BUILD_DEMOS)
ADD_SUBDIRECTORY(graph_display)
ADD_SUBDIRECTORY(clique_import)
ADD_SUBDIRECTORY(graph_manipulations)
ENDIF(BUILD_DEMOS)

=== doc/CMakeLists.txt ===
SET(BUILD_DOC ON CACHE BOOL "Do you want to build the documentation ? [ON|OFF]")

#Only
IF(BUILD_DOC)
  # Unset the previous values of the CMake cache variable SPHINX_EXECUTABLE
  # in case the value of PYTHON_EXECUTABLE CMake variable changed
  UNSET(SPHINX_EXECUTABLE CACHE)
  SET(Sphinx_DIR ${CMAKE_CURRENT_SOURCE_DIR}/python)
  MARK_AS_ADVANCED(Sphinx_DIR)
  FIND_PACKAGE(Sphinx)
  IF(SPHINX_FOUND)
    IF(BUILD_PYTHON_COMPONENTS)
      ADD_SUBDIRECTORY(python)
    ENDIF(BUILD_PYTHON_COMPONENTS)
    IF(NOT ACTIVATE_PYTHON_WHEELS_TARGETS)
      ADD_SUBDIRECTORY(user)
      ADD_SUBDIRECTORY(developer)
    ENDIF(NOT ACTIVATE_PYTHON_WHEELS_TARGETS)
  ELSE(SPHINX_FOUND)
    MESSAGE(AUTHOR_WARNING "Sphinx not found: unable to generate the documentation.")
  ENDIF(SPHINX_FOUND)

  IF(LINUX OR APPLE)
    IF(NOT ACTIVATE_PYTHON_WHEELS_TARGETS)
      FIND_PACKAGE(Doxygen)
      IF(DOXYGEN_FOUND)
        ADD_SUBDIRECTORY(doxygen)
      ELSE(DOXYGEN_FOUND)
        MESSAGE(AUTHOR_WARNING "doxygen not found: unable to generate the documentation.")
      ENDIF(DOXYGEN_FOUND)
    ENDIF(NOT ACTIVATE_PYTHON_WHEELS_TARGETS)
  ENDIF(LINUX OR APPLE)
ENDIF(BUILD_DOC)

=== externalplugins/CMakeLists.txt ===
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

#Automatic subdirectory search for CMakeLists.txt
FILE(GLOB CM_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*/CMakeLists.txt)

SET(EXTERNALPLUGINS TRUE)

FOREACH(CM_FILE ${CM_FILES})
STRING(REGEX REPLACE "/CMakeLists.txt" "" CM_SUBDIR ${CM_FILE})
ADD_SUBDIRECTORY(${CM_SUBDIR})
ENDFOREACH(CM_FILE)

=== library/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt)

ADD_SUBDIRECTORY(tulip-core)
ADD_SUBDIRECTORY(tulip-ogdf)
IF(NOT BUILD_CORE_ONLY)
ADD_SUBDIRECTORY(tulip-ogl)
ADD_SUBDIRECTORY(tulip-gui)
IF(BUILD_PYTHON_COMPONENTS)
ADD_SUBDIRECTORY(tulip-python)
ENDIF(BUILD_PYTHON_COMPONENTS)
ENDIF(NOT BUILD_CORE_ONLY)

=== plugins/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt)

IF(CHECK_MEMORY)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CHECK_MEMORY_FLAGS}")
ENDIF(CHECK_MEMORY)

ADD_SUBDIRECTORY(clustering)
ADD_SUBDIRECTORY(export)
ADD_SUBDIRECTORY(general)
ADD_SUBDIRECTORY(import)
ADD_SUBDIRECTORY(layout)
ADD_SUBDIRECTORY(metric)
ADD_SUBDIRECTORY(selection)
ADD_SUBDIRECTORY(sizes)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(colors)
IF(NOT BUILD_CORE_ONLY)
ADD_SUBDIRECTORY(glyph)
ADD_SUBDIRECTORY(interactor)
# Tulip perspective is not bundled in tulipgui Python wheel
IF(NOT ACTIVATE_PYTHON_WHEELS_TARGETS)
ADD_SUBDIRECTORY(perspective)
ENDIF(NOT ACTIVATE_PYTHON_WHEELS_TARGETS)
ADD_SUBDIRECTORY(string)
ADD_SUBDIRECTORY(view)
ENDIF(NOT BUILD_CORE_ONLY)

=== thirdparty/CMakeLists.txt ===
DISABLE_COMPILER_WARNINGS()

ADD_CORE_FILES(CMakeLists.txt)

ADD_SUBDIRECTORY(gzstream)
ADD_SUBDIRECTORY(OGDF)
ADD_SUBDIRECTORY(libqhull)
ADD_SUBDIRECTORY(yajl)
IF(NOT BUILD_CORE_ONLY)
ADD_SUBDIRECTORY(ftgl)
ADD_SUBDIRECTORY(libtess2)
IF(NOT QUAZIP_FOUND)
  ADD_SUBDIRECTORY(quazip)
ENDIF(NOT QUAZIP_FOUND)
ADD_SUBDIRECTORY(qxt)
ADD_SUBDIRECTORY(QtAwesome)

IF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
  IF(SIP_OK AND NOT SIP_FOUND)
    ADD_SUBDIRECTORY(sip-${SIP_VERSION_THIRDPARTY})
  ENDIF(SIP_OK AND NOT SIP_FOUND)
ENDIF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
ENDIF(NOT BUILD_CORE_ONLY)

## -----------------------------------------------------------------------------------------------
## Install external libraries.
## Each external library is defined in its own component to ensure easy modifications of the CPack component dependency tree
## -----------------------------------------------------------------------------------------------

IF(WIN32)
## -----------------------------------------------------------------------------------------------
## Windows
## -----------------------------------------------------------------------------------------------

# Note: On Win32 systems, CMake variables doesn't provide the right libraries that have to be included in the bundle. (For instance, Qt variables redirect to .lib and not .dll)
#       We have to manually find those libs by invoking the FIND_LIBRARY_GLOB macro

# Base System
# Libs needed to provide sufficient runtime under Windows environments
  IF(MINGW)



    # base runtime
    INSTALL_EXTERNAL_LIB("libgcc_s_*.dll" runtime)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("libgcc_s_*.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("libstdc++-*.dll" runtime)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("libstdc++-*.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    # install libintl and its dependency libiconv if found in the MinGW build environment
    IF(LIBINTL_FOUND)
      INSTALL_EXTERNAL_LIB("libintl*.dll" intl)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("libintl*.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

      INSTALL_EXTERNAL_LIB("*iconv.dll" iconv)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("*iconv.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    ENDIF(LIBINTL_FOUND)

    # install pthread lib in all cases as it is a frequent dependency
    INSTALL_EXTERNAL_LIB("*pthread*.dll" runtime)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("*pthread*.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    # OpenMP runtime
    IF(OPENMP_FOUND)
      INSTALL_EXTERNAL_LIB("libgomp-*.dll" runtime)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("libgomp-*.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    ENDIF(OPENMP_FOUND)

    # dependencies for old MinGW compilers
    IF(GCXX_VERSION VERSION_LESS 4.8)
      INSTALL_EXTERNAL_LIB("mingwm*.dll" runtime)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("mingwm*.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

      INSTALL_EXTERNAL_LIB("libiconv-2.dll" iconv)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("libiconv-2.dll" ${TULIP_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    ENDIF(GCXX_VERSION VERSION_LESS 4.8)

  ENDIF(MINGW)

  INSTALL_EXTERNAL_LIB_IF_NEEDED(${ZLIB_LIBRARY} zlib)
  IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    COPY_EXTERNAL_LIB_IF_NEEDED(${ZLIB_LIBRARY} ${TULIP_PYTHON_NATIVE_FOLDER})
  ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

IF(NOT BUILD_CORE_ONLY)
  INSTALL_EXTERNAL_LIB_IF_NEEDED(${GLEW_LIBRARY} glew)
  IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    COPY_EXTERNAL_LIB_IF_NEEDED(${GLEW_LIBRARY} ${TULIPOGL_PYTHON_NATIVE_FOLDER})
  ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

  INSTALL_EXTERNAL_LIB_IF_NEEDED(${FREETYPE_LIBRARY} freetype)
  IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    COPY_EXTERNAL_LIB_IF_NEEDED(${FREETYPE_LIBRARY} ${TULIPOGL_PYTHON_NATIVE_FOLDER})
  ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

  INSTALL_EXTERNAL_LIB_IF_NEEDED(${JPEG_LIBRARY} jpeg)
  IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    COPY_EXTERNAL_LIB_IF_NEEDED(${JPEG_LIBRARY} ${TULIPOGL_PYTHON_NATIVE_FOLDER})
  ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

  INSTALL_EXTERNAL_LIB_IF_NEEDED(${PNG_LIBRARY} png)
  IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
    COPY_EXTERNAL_LIB_IF_NEEDED(${PNG_LIBRARY} ${TULIPOGL_PYTHON_NATIVE_FOLDER})
  ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

  IF(USE_QT4)
    INSTALL_EXTERNAL_LIB("QtCore4.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("QtCore4.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("QtGui4.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("QtGui4.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("QtNetwork4.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("QtNetwork4.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("QtOpenGL4.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("QtOpenGL4.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("QtXml4.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("QtXml4.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("QtWebKit4.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("QtWebKit4.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    IF(CMAKE_DEBUG_MODE OR MSVC)
      INSTALL_EXTERNAL_LIB("QtCored4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtGuid4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtNetworkd4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtOpenGLd4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtXmld4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtWebKitd4.dll" qt)
    ENDIF(CMAKE_DEBUG_MODE OR MSVC)

    IF(QT_PHONON_LIBRARY)
      INSTALL_EXTERNAL_LIB("phonon4.dll" qt)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("phonon4.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

      IF(CMAKE_DEBUG_MODE OR MSVC)
        INSTALL_EXTERNAL_LIB("phonond4.dll" qt)
      ENDIF(CMAKE_DEBUG_MODE OR MSVC)
    ENDIF(QT_PHONON_LIBRARY)
  ENDIF(USE_QT4)

  IF(USE_QT5)
    INSTALL_EXTERNAL_LIB("Qt5Core.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Core.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Gui.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Gui.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Network.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Network.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5OpenGL.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5OpenGL.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Xml.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Xml.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5WebKit.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5WebKit.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5WebKitWidgets.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5WebKitWidgets.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Widgets.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Widgets.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Multimedia.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Multimedia.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5MultimediaWidgets.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5MultimediaWidgets.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5PrintSupport.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5PrintSupport.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Sensors.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Sensors.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Sql.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Sql.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Quick.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Quick.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("Qt5Qml.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("Qt5Qml.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    IF(CMAKE_DEBUG_MODE OR MSVC)
      INSTALL_EXTERNAL_LIB("Qt5Cored.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Guid.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Networkd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5OpenGLd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Xmld.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5WebKitd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5WebKitWidgetsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Widgetsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Multimediad.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5MultimediaWidgetsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5PrintSupportd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Sensorsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Sqld.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Quickd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Qmld.dll" qt)
    ENDIF(CMAKE_DEBUG_MODE OR MSVC)

    INSTALL_EXTERNAL_LIB("icuin*.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("icuin*.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("icuuc*.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("icuuc*.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    INSTALL_EXTERNAL_LIB("icudt*.dll" qt)
    IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
      COPY_EXTERNAL_LIB("icudt*.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
    ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

    IF(QT_VERSION VERSION_LESS 5.2)
      INSTALL_EXTERNAL_LIB("Qt5V8.dll" qt)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("Qt5V8.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

      IF(CMAKE_DEBUG_MODE OR MSVC)
        INSTALL_EXTERNAL_LIB("Qt5V8d.dll" qt)
      ENDIF(CMAKE_DEBUG_MODE OR MSVC)
    ELSE(QT_VERSION VERSION_LESS 5.2)
      INSTALL_EXTERNAL_LIB("Qt5Positioning.dll" qt)
      IF(ACTIVATE_PYTHON_WHEELS_TARGETS)
        COPY_EXTERNAL_LIB("Qt5Positioning.dll" ${TULIPGUI_PYTHON_NATIVE_FOLDER})
      ENDIF(ACTIVATE_PYTHON_WHEELS_TARGETS)

      IF(CMAKE_DEBUG_MODE OR MSVC)
        INSTALL_EXTERNAL_LIB("Qt5Positioningd.dll" qt)
      ENDIF(CMAKE_DEBUG_MODE OR MSVC)
    ENDIF(QT_VERSION VERSION_LESS 5.2)

    IF(QT_VERSION VERSION_GREATER 5.3)
      INSTALL_EXTERNAL_LIB("Qt5WebChannel.dll" qt)

=== tlpscripten/CMakeLists.txt ===
ADD_CORE_FILES(.)

## ========================================================
## Configure file for directories initialization
## ========================================================
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/init_dirs.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/init_dirs.sh" IMMEDIATE @ONLY)

## ========================================================
## copy scripts from src dir to bin dir
## ========================================================
FILE(GLOB SCRIPTS ${CMAKE_CURRENT_SOURCE_DIR}/*.sh)

ADD_CUSTOM_TARGET(copy_scripts)
FOREACH(script ${SCRIPTS})
  ADD_CUSTOM_COMMAND(TARGET copy_scripts PRE_BUILD
                     COMMAND ${CMAKE_COMMAND} -E
                     copy_if_different ${script} ${CMAKE_CURRENT_BINARY_DIR})
ENDFOREACH()

## ========================================================
## invoke main script
## ========================================================
ADD_CUSTOM_TARGET(tlpscripten sh tlpscripten.sh
                  DEPENDS copy_scripts)

=== unit_test/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt FindCppUnit.cmake)

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})

FIND_PACKAGE(CppUnit REQUIRED)

MACRO(UNIT_TEST)
  SET(TEST_NAME ${ARGV0})
  UNSET(TEST_SRCS)
  FOREACH(loop_var ${ARGN})
    STRING(REGEX MATCH ".*\\.cpp" TEST_SRC_FILE ${loop_var})
    IF(TEST_SRC_FILE)
      SET(TEST_SRCS ${TEST_SRCS} ${loop_var})
    ENDIF(TEST_SRC_FILE)
  endforeach()
  ADD_EXECUTABLE(${TEST_NAME} ${TEST_SRCS})
  ADD_DEPENDENCIES(runTests ${TEST_NAME})
  TARGET_LINK_LIBRARIES(${TEST_NAME} ${LibTulipCoreName} ${CppUnit_LIBRARIES})
  ADD_TEST(NAME ${TEST_NAME} COMMAND ${TEST_NAME} ${TEST_NAME})
  # In order to run the tests on windows, we need to add the paths of the dll depencencies (cppunit, tulip, gzstream, yajl)
  # in the PATH environment variable
  IF(WIN32)
    IF(MINGW)
      STRING(REGEX MATCH ".*dll\\.a" IMPORT_LIBRARY ${CppUnit_LIBRARIES})
      STRING(REGEX MATCH ".*dll" DLL_LIBRARY ${CppUnit_LIBRARIES})
      IF(IMPORT_LIBRARY)
        GET_DLL_NAME_FROM_IMPORT_LIBRARY(${CppUnit_LIBRARIES} CppUnitDllName)
      ELSEIF(DLL_LIBRARY)
        GET_FILENAME_COMPONENT(CppUnitDllName ${CppUnit_LIBRARIES} NAME)
      ENDIF()
    ELSE(MINGW)
      GET_DLL_NAME_FROM_IMPORT_LIBRARY(${CppUnit_LIBRARIES} CppUnitDllName)
    ENDIF(MINGW)
    IF(CppUnitDllName)
      FIND_EXTERNAL_LIB(${CppUnitDllName} CppUnitDllPath)
      IF(CppUnitDllPath)
        GET_FILE_DIRECTORY(${CppUnitDllPath} CppUnitDllDir)
      ENDIF(CppUnitDllPath)
    ENDIF()
    SET(NEWPATH "${CppUnitDllDir};${QT_BINARY_DIR};${CMAKE_BINARY_DIR}/thirdparty/gzstream/;${CMAKE_BINARY_DIR}/thirdparty/yajl/src;${CMAKE_BINARY_DIR}/thirdparty/quazip;${CMAKE_BINARY_DIR}/thirdparty/ftgl;${CMAKE_BINARY_DIR}/thirdparty/qxt")
    SET(NEWPATH "${NEWPATH};${CMAKE_BINARY_DIR}/library/tulip-core/src;${CMAKE_BINARY_DIR}/library/tulip-ogl/src;${CMAKE_BINARY_DIR}/library/tulip-gui/src;$ENV{PATH}")
    STRING(REPLACE ";" "\\;" NEWPATH "${NEWPATH}")
    SET_TESTS_PROPERTIES(${TEST_NAME} PROPERTIES ENVIRONMENT "PATH=${NEWPATH}")
  ENDIF(WIN32)
ENDMACRO(UNIT_TEST)

ADD_SUBDIRECTORY(library)

IF(NOT BUILD_CORE_ONLY)
ADD_SUBDIRECTORY(plugins)
ENDIF(NOT BUILD_CORE_ONLY)

=== bundlers/win/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Tulip.nsi.in ${CMAKE_CURRENT_BINARY_DIR}/Tulip.nsi @ONLY)

=== doc/doxygen/CMakeLists.txt ===
# this doc is only build & installed on linux or MacOSX
# when doxygen is available
# check for dot to enable the generation of class diagrams
IF(DOXYGEN_DOT_FOUND)
  SET(DOXY_HAVE_DOT "YES")
ELSE(DOXYGEN_DOT_FOUND)
  SET(DOXY_HAVE_DOT "NO")
  MESSAGE(AUTHOR_WARNING "dot tool not found: doxygen diagrams and graphs will not be generated")
ENDIF(DOXYGEN_DOT_FOUND)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/tulip.doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/tulip.doxyfile)

ADD_CUSTOM_TARGET(doxydoc ALL
  ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/html
  COMMAND doxygen ${CMAKE_CURRENT_BINARY_DIR}/tulip.doxyfile
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_SOURCE_DIR}/doc/html ${CMAKE_CURRENT_BINARY_DIR}/html
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/style/doxygen.css ${CMAKE_CURRENT_BINARY_DIR}/html
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/style/navtree.css ${CMAKE_CURRENT_BINARY_DIR}/html
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/style/tabs.css ${CMAKE_CURRENT_BINARY_DIR}/html
  COMMAND ${CMAKE_COMMAND} -E remove_directory ${PROJECT_SOURCE_DIR}/doc/html
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR} VERBATIM)

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html 
  DESTINATION ${TulipShareInstallDir}/doc/doxygen
  COMPONENT doxygen_doc)

=== debian/changelog ===
tulip (4.8.0dfsg-2build2) xenial; urgency=medium

  * No-change rebuild for binutils 2.26.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Jan 2016 16:44:24 +0000

tulip (4.8.0dfsg-2build1) xenial; urgency=medium

  * No-change rebuild for updated binutils.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Jan 2016 11:00:50 +0100

tulip (4.8.0dfsg-2) unstable; urgency=medium

  * Don't record a build date, which would anyway AFAICT never be
    reported, fixing build-reproducibility issue.

 -- Yann Dirson <dirson@debian.org>  Mon, 28 Dec 2015 23:19:01 +0100

tulip (4.8.0dfsg-1) unstable; urgency=medium

  * New upstream release:
    * Fixes amd64 FTBTS (Closes: #803311).
    * New thirdparty lib libtess2, adding to debian/copyright.
    * Make sure everything python is under dist-packages, and installed
      in main package, leaving only the libtulip-python shlib in its
      own package.
  * Replace more occurrences of __linux and __linux__ with __unix__.
  * Cleanup of debian/README.maint.
  * Fixed location of CPL license text (not to be installed in a directory
    of same name as uncompressed file).
  * Switch repacked upstream tarball to xz compression.

 -- Yann Dirson <dirson@debian.org>  Tue, 01 Dec 2015 23:48:46 +0100

tulip (4.7.0dfsg-2) unstable; urgency=medium

  * Rebuild with g++-5, no library transition needed as 4.7 has not
    entered testing yet.

 -- Yann Dirson <dirson@debian.org>  Mon, 07 Sep 2015 22:38:54 +0200

=== debian/control ===
Source: tulip
Section: graphics
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>= 9), cmake, qtbase5-dev, libqt5opengl5-dev, libqt5webkit5-dev, libqt5xmlpatterns5-dev, freeglut3-dev, docbook-to-man, libgl1-mesa-dev | libgl-dev, dh-buildinfo, libfreetype6-dev, libxml2-dev, libgle3-dev, libxml2-utils, graphviz, libjpeg-dev, libpng-dev, libftgl-dev, libglew-dev, binutils-dev [linux-i386 kfreebsd-i386 any-amd64], python-sip-dev, libutfcpp-dev
Homepage: http://tulip-software.org/
Standards-Version: 3.9.6
Vcs-git: git://anonscm.debian.org/collab-maint/tulip.git
Vcs-browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tulip.git

Package: tulip
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-dejavu-core, fonts-font-awesome
Description: System dedicated to the visualization of huge data sets as graphs
 Tulip is an information visualization framework dedicated to the
 analysis and visualization of relational data.  It aims to provide
 the developer with a complete library, supporting the design of
 interactive information visualization applications for relational
 data that can be tailored to the problems he or she is addressing.
 .
 It includes the following features:
 .
  * 3D visualizations
  * 3D modifications
  * Plug-in support for easy evolution
  * Building of clusters and navigation into them
  * Automatic drawing of graphs
  * Automatic clustering of graphs
  * Automatic selection of elements
  * Automatic metric coloration of graphs

Package: tulip-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tulip (= ${binary:Version})
Description: Tulip graph library - debug symbols
 Debug symbols for tulip, a system dedicated to the visualization of
 huge graphs, and its various libraries.

Package: libtulip-dev
Section: libdevel
Architecture: any
Depends: tulip (= ${binary:Version}), libc6-dev, ${misc:Depends}
Conflicts: libtulip-dev
Replaces: tulip (<= 2), libtulip-ogl-dev, libtulip-qt4-dev
Suggests: cmake
Enhances: qtcreator
Description: Tulip graph library - core development files
 Headers and static libraries for tulip, a system dedicated to the
 visualization of huge graphs.  Also include QtCreator templates.

Package: libtulip-core-4.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - core runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-ogl-4.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OpenGL runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the OpenGL rendering capabilities of the engine.

Package: libtulip-gui-4.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - Qt/OpenGL GUI runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Qt/OpenGL GUI support.

Package: libtulip-python-4.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libtulip-python
Conflicts: libtulip-python
Description: Tulip graph library - Python support
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Python scripting support.

Package: libtulip-ogdf-4.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OGDF runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Open Graph Drawing Framework support.

Package: libogdf-tulip-4.8-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Open Graph Drawing Framework shared library, built for Tulip
 This is the Open Graph Drawing Framework library, built as a shared
 lib as required by Tulip.

Package: libgzstream-tulip-4.8-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gzstream shared library, built for Tulip
 C++ iostream classes wrapping the zlib compression library, built as
 a shared lib as required by Tulip.

Package: libquazip-tulip-4.8-1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: quazip shared library, built for Tulip
 Runtime for the quazip C++ wrapper for ZIP/UNZIP, built as a
 shared lib as required by Tulip.

Package: libqxt-tulip-4.8-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: qxt shared library, built for Tulip
 Runtime for a subset of Qxt, extensions to Qt core classes, built as
 a shared lib as required by Tulip.

Package: libyajl-tulip-4.8-2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: yajl shared library, built for Tulip
 Runtime for yajl, Yet Another JSON Library, built as a shared lib as
 required by Tulip.

Package: libtess2-tulip-4.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: yajl shared library, built for Tulip
 Runtime for yajl, Yet Another JSON Library, built as a shared lib as
 required by Tulip.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH:BOOL=YES -DUBUNTU_PPA_BUILD=ON -DBUILD_DOC=OFF -DUSE_QT5_IF_INSTALLED=YES

override_dh_auto_build-arch:
	dh_auto_build --parallel
	docbook-to-man debian/tulip.sgml > debian/tulip.1

override_dh_auto_install-arch:
	dh_auto_install
	install -D -m644 debian/tulip.1 debian/tmp/usr/share/man/man1/tulip.1
	install -D -m644 debian/tulip.desktop debian/tmp/usr/share/applications/tulip.desktop
	install -D -m644 debian/TulipIcon.png debian/tmp/usr/share/pixmaps/TulipIcon.png
 # fixup install location for python files
	mkdir -p debian/tmp/usr/lib/python2.7
	test ! -r debian/tmp/usr/lib/python2.7/dist-packages
	mv debian/tmp/usr/lib/python debian/tmp/usr/lib/python2.7/dist-packages
 # apply README instructions: install qtcreator templates in the correct place
	mkdir -p debian/tmp/usr/share/qtcreator/templates
	mv debian/tmp/usr/share/tulip/wizards/* debian/tmp/usr/share/qtcreator/templates/
	rmdir debian/tmp/usr/share/tulip/wizards
	rm debian/tmp/usr/share/qtcreator/templates/README.txt

override_dh_install:
	dh_install --fail-missing

override_dh_installdocs:
	dh_installdocs
	dh_buildinfo

override_dh_strip:
	dh_strip --dbg-package tulip-dbg

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/tulip.1
	rm -rf docs/doxygen/xml

=== debian/watch ===
version=3
opts=dversionmangle=s/dfsg$// \
 http://sf.net/auber/tulip-([\d.]*)(?:[-_]src\.tar\.gz|\.tar\.bz2)
